//class MyThread extends Threads...

class Threads extends Thread {
  Complex zNeu,zAlt,C,z0;
  double xmin,ymin;
  double y=0;
  double x=0;
  color farbe;
  PGraphics pg;
  int maxiterations;
  int tN;
  int maxN =0; //Kontrolle
  double massFuerUnendlich;
  double wh;
  double nZwischen;
  protected boolean running = false;
  int zaehlen;
  boolean julia;
  double aQMax =0;
  double x0 ;
  double y0 ;
  int farbIndex =0;
  int farbWert = 0;
  int trapFaktor;
  int farbNummer =0;
  int hell =0;
  int ordnungSpreizung = 1000; //bestimmt, wie stark die Farben im Bereich der Ordung variieren.
  double aQ,laenge;
  double r,R;
  double mR,mI;
  boolean inEinemKreis = false;
  Complex [][] MP;
  int [][] kFarbe;
  double trapAbstandX;
  double trapAbstandY;
  double d;
  boolean trapped;
  boolean parallelXAchse = false;
  boolean parallelYAchse = false;
  int max = 0;//temp Hilfgröße
  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, int nummer, double X0, double Y0, boolean Julia) {
    // benötigte Parameter
    tN = nummer; 
    wh = pwh;
    xmin=px0; ymin=py0; 
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    aQ =0;  
    C = new Complex(X0,Y0);
    d=0;
    trapAbstandX = 0.005;//für kleineren trapAbstand trapFaktor größer wählen: zB. 0.01 und 5000
    trapAbstandY = 0.005;
    trapFaktor = 5000; 
    r=0.04; //Radius der Kreise
   
    MP = new Complex [7][7];
    kFarbe = new int [7][7];
    for (int i =-3; i<4; i++){//Kreismittelpunkte
      for(int j =-3; j<4;j++){
        MP[i+3][j+3] = new Complex(0.5*i,0.5*j); 
        kFarbe[i+3][j+3] = (i+4)*(j+4)*15%256; 
      }
    }
    pg = createGraphics(width,height/anzahlThreads);
    julia = Julia;   
  }
  
 public int gibNummer(){  
    return tN;   
  }

 //////////////////////////////////////////////////////////////
  
  public void run() {
    tN =this.gibNummer(); 
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
       
        double ymax = ymin + wh;
       
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
            if(julia){ 
            int n = juliaIteration(z0);
            pg.pixels[i+j*pg.width] = colorize(n);
             
           }else{
             int n = mandelbrotIteration(z0);          
            pg.pixels[i+j*pg.width] = colorize(n);
            }         
            x += dx; 
          }
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
   
  }
  
/////////////////////////////////////////////////////////////////////
int juliaIteration(Complex Z0) {
 
  // nun wird für eine komplexe Zahl bzw. einen Punkt der Ebene getestet, 
  // wohin er bei der Iteration geht. Je nachdem wird er dann später eingefärbt 
 
  int n = 0;
  trapped = false;
  zAlt = Z0;
  while (n < maxiterations) {
    zNeu = zAlt.multiply(zAlt);
    zNeu = zNeu.multiply(zAlt);
    zNeu = zNeu.addC(C);
    laenge =zNeu.getLength();
    aQ = ordnungSpreizung*laenge;
    if (laenge > massFuerUnendlich) {
      break;  // Bail
    }  
    
    //trifft einen von 49 Kreisen
    int s=-3; 
    int t=-3;
    double b=0;
    while(s<4){
      t=-3;
      while(t<4){
        b= MP[s+3][t+3].subtractC(zNeu).getLength();
        if (b < r){
            trapped = true;
            inEinemKreis = true;
            hell = (int)(2048*b);
            farbWert = kFarbe[s+3][t+3];
            n =hell % 256;  
            t=4;// bewirkt break
         } 
         if(trapped) break;
         t++;
      }
      if(trapped) break;
    s++;  
    } 
    if(trapped) break;
   
    x= zNeu.getRealPart();
    int i = -4;
   //senkrechte Achsen
   while(i<4){
     i++;
     if (Math.abs(0.5*i-x)< trapAbstandY){
        d=Math.abs(0.5*i-x);
        nZwischen = trapFaktor*d;  
        parallelYAchse = true;
        farbNummer =3+i;
        trapped = true;  n = (int)nZwischen; 
        i = 4;
      }
   } 
   if(trapped) break;
   
    y =zNeu.getImaginaryPart();
    int j = -4;
   //waagrechte Achsen
   while(j<4){
     j++;
     if (Math.abs(0.5*j-y)< trapAbstandY){
        d=Math.abs(0.5*j-y);
        nZwischen = trapFaktor*d;  
        parallelXAchse = true;
        farbNummer =3+j;
        trapped = true;  n = (int)nZwischen; 
        j = 4;
      }
   } 
   if(trapped) break;
        
   zAlt = zNeu;
   n++;
  }//end of main while
  return n;
 }
 /////////////////////////////////////////////////////////////////////
int mandelbrotIteration(Complex C) {
  julia =false;
  trapped = false;
  int n = 0;
  zAlt = C;
  while (n < maxiterations) {
    zNeu =zAlt.multiply(zAlt);
    zNeu = zNeu.multiply(zAlt);
    zNeu = zNeu.addC(C);
    laenge =zNeu.getLength();
    aQ = 1000*laenge; 
    if (laenge > massFuerUnendlich) {
      break;  // Bail
    }
    zAlt = zNeu;
    n++;
  }  
  return n;
 }
 
////////////////////////////////////////////////////////////////////
color colorize(int n) {
  // jedes Pixel wird entsprechend der Anzahl Iterationen eingefärbt
  
  if (n == maxiterations){//Ordnung
    farbIndex = (int) aQ % 1024;
    color colOrdnung  = farben.farben1024B[farbIndex];  
    
    return colOrdnung;
  }else if(!trapped){  //Chaos ohne Tap
    farbIndex = 4*n % 8192;
    farbe = farben.farben8192Bonbon[farbIndex];
    return farbe; 
  }else {//trapped   
    if(inEinemKreis){
       colorMode(HSB,256,256,256);
       hell = 256-hell;
       farbe = color(farbWert,255,hell);
       inEinemKreis = false;
    }
    farbIndex =8*n % 1024;//modulo zur Sicherheit 
    
    if(parallelXAchse){
      //farbe =farben.farbenTrapBlau1024[farbIndex];  //nützlich zur Indentifizierung
      farbe = farben.farbenTrapZufall1024[1][farbIndex];  
      parallelXAchse= false;
    }   
    
     if(parallelYAchse) {
      //farbe =farben.farbenTrapRot1024[farbIndex]; //nützlich zur Indentifizierung
      farbe = farben.farbenTrapZufall1024[farbNummer][farbIndex];  
     
       parallelYAchse= false;
    }
      
    return farbe;
  }
 }
}
